import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useState as g, useMemo as M, useCallback as V, useEffect as ee } from "react";
import { theme as te, Table as v, Row as f, Col as a, Space as _, Form as h, Select as C, Spin as se, Typography as B, Pagination as re, Tooltip as le, Flex as oe, Empty as O } from "antd";
import A from "../../BitzButton/index.mjs";
import ce from "../../BitzDescriptions/index.mjs";
import { getLayoutConfig as ne } from "./layouts.mjs";
import "./index.less.mjs";
import ie from "../../../node_modules/@ant-design/icons/es/icons/InfoCircleOutlined.mjs";
import ae from "../../../node_modules/@ant-design/icons/es/icons/CloseOutlined.mjs";
function ye({
  columns: T,
  tableData: F,
  total: K,
  loading: m,
  loadingFailed: y,
  loadAgain: L,
  page: P,
  onPageChange: U,
  searchInput: D,
  showToolTagSelect: z,
  toolTags: G,
  onToolTagChange: w,
  lrLayout: b,
  parentRender: E,
  keys: I,
  rows: R,
  fieldNames: s,
  onChange: u,
  onDropdownVisibleChange: j
}) {
  const { token: d } = te.useToken(), [o, H] = g([]), [l, J] = g([]), [Q, W] = g(void 0), X = (t, r) => {
    W(t), w == null || w(t, r), t || (j(!0), setTimeout(() => {
      j(!1);
    }, 0));
  }, $ = M(() => [
    v.SELECTION_COLUMN,
    v.EXPAND_COLUMN,
    {
      title: "序号",
      rowScope: "row",
      className: "numRow",
      width: 50,
      render: (t, r, c) => c + 1
    },
    ...T
  ], [T]), q = {
    selectedRowKeys: o,
    onSelect: (t, r) => {
      if (r)
        o.push(t[s.value]), l.push(t), u(o, l);
      else {
        const c = l.filter(
          (p) => p[s.value] !== t[s.value]
        );
        u(
          c.map((p) => p[s.value]),
          c
        );
      }
    },
    onSelectAll: (t, r, c) => {
      const p = c.map((i) => i[s.value]);
      if (t) {
        const i = o.concat(p), S = l.concat(c);
        u(i, S);
      } else {
        const i = o == null ? void 0 : o.filter((x) => !p.includes(x)), S = /* @__PURE__ */ new Map();
        c.forEach((x) => {
          S.set(x[s.value], x);
        });
        const N = l == null ? void 0 : l.filter(
          (x) => !S.has(x[s.value])
        );
        u(i, N);
      }
    }
    // onChange: (newKeys: Key[], newRows: DataType[]) => {
    //   // setSelectedRowKeys(selectedRowKeys)
    //   // setSelectedRows(selectedRows)
    //   onChange([...newKeys], [...newRows])
    // },
    // selections: [
    //   Table.SELECTION_ALL,
    //   Table.SELECTION_INVERT,
    //   Table.SELECTION_NONE,
    //   {
    //     key: 'odd',
    //     text: '选择当页奇数行',
    //     onSelect: (changeableRowKeys) => {
    //       let newSelectedRowKeys: Key[] = []
    //       newSelectedRowKeys = changeableRowKeys.filter((_, index) => {
    //         if (index % 2 !== 0) {
    //           return false
    //         }
    //         return true
    //       })
    //       let newSelectedRows: DataType[] = []
    //       newSelectedRows = tableData.filter((v) => {
    //         return newSelectedRowKeys.includes(v[fieldNames.value])
    //       })
    //       onChange(newSelectedRowKeys, newSelectedRows)
    //     },
    //   },
    //   {
    //     key: 'even',
    //     text: '选择当页偶数行',
    //     onSelect: (changeableRowKeys) => {
    //       let newSelectedRowKeys: Key[] = []
    //       newSelectedRowKeys = changeableRowKeys.filter((_, index) => {
    //         if (index % 2 !== 0) {
    //           return true
    //         }
    //         return false
    //       })
    //       let newSelectedRows: DataType[] = []
    //       newSelectedRows = tableData.filter((v) => {
    //         return newSelectedRowKeys.includes(v[fieldNames.value])
    //       })
    //       onChange(newSelectedRowKeys, newSelectedRows)
    //     },
    //   },
    // ],
  }, Y = V(() => {
    if (s.items) {
      const t = s.items;
      return {
        expandable: {
          expandedRowRender: (r) => /* @__PURE__ */ e.jsx(
            ce,
            {
              size: "small",
              bordered: !0,
              items: r[t],
              column: { xs: 1, sm: 1, md: 1, lg: 2, xl: 2, xxl: 2 }
            }
          )
        }
      };
    }
    return null;
  }, [s.items]), k = (t, r) => /* @__PURE__ */ e.jsxs("span", { style: { color: d.colorText }, children: [
    t[0],
    " ",
    /* @__PURE__ */ e.jsx("span", { style: { color: d.colorPrimary, fontWeight: 600 }, children: r }),
    " ",
    t[1]
  ] }), Z = () => {
    const t = (r) => {
      const c = l.findIndex(
        (i) => i[s.value] === r[s.value]
      ), p = o.findIndex(
        (i) => i === r[s.value]
      );
      l.splice(c, 1), o.splice(p, 1), u(o, l);
    };
    return /* @__PURE__ */ e.jsxs(
      _,
      {
        direction: "vertical",
        style: {
          width: "calc(100% - 5px)",
          paddingRight: 5,
          maxHeight: l.length ? 220 : "auto",
          overflow: "hidden auto"
        },
        children: [
          l.map((r, c) => /* @__PURE__ */ e.jsx(le, { placement: "right", title: r[s.label], children: /* @__PURE__ */ e.jsxs(
            oe,
            {
              justify: "space-between",
              style: {
                padding: "4px 8px",
                border: `1px solid ${d.colorBorder}`,
                backgroundColor: "#fafafa",
                borderRadius: d.borderRadiusSM,
                overflow: "hidden"
              },
              children: [
                /* @__PURE__ */ e.jsx(B.Text, { ellipsis: !0, style: { width: "calc(100% - 24px)" }, children: r[s.label] }),
                /* @__PURE__ */ e.jsx(
                  ae,
                  {
                    style: { color: "#ff4d4f", fontSize: 13, cursor: "pointer" },
                    onClick: () => t(r)
                  }
                )
              ]
            }
          ) }, c)),
          !l.length && /* @__PURE__ */ e.jsx(O, { image: O.PRESENTED_IMAGE_SIMPLE })
        ]
      }
    );
  };
  ee(() => {
    H(I ?? []), J(R ?? []);
  }, [I, R]);
  const n = M(() => ne(b, z), [b, z]);
  return /* @__PURE__ */ e.jsxs(f, { gutter: n.gutter, children: [
    /* @__PURE__ */ e.jsx(a, { span: n.left.span, children: b && E && E(n.spaceSize) }),
    /* @__PURE__ */ e.jsx(a, { span: n.right.span, children: /* @__PURE__ */ e.jsxs(
      _,
      {
        direction: "vertical",
        size: n.spaceSize,
        style: { width: "100%" },
        children: [
          /* @__PURE__ */ e.jsx(h, { className: "tableSelectPopupSearchForm", children: /* @__PURE__ */ e.jsx(f, { gutter: [16, 16], children: /* @__PURE__ */ e.jsx(a, { span: 24, children: /* @__PURE__ */ e.jsxs(f, { justify: "space-between", gutter: [16, 16], children: [
            /* @__PURE__ */ e.jsx(a, { span: n.right.search, children: /* @__PURE__ */ e.jsx(h.Item, { children: D }) }),
            /* @__PURE__ */ e.jsx(a, { span: n.right.operation, children: /* @__PURE__ */ e.jsxs(f, { justify: "end", gutter: 8, children: [
              /* @__PURE__ */ e.jsx(a, { span: n.right.toolTagSelect, children: /* @__PURE__ */ e.jsx(h.Item, { children: /* @__PURE__ */ e.jsx(
                C,
                {
                  allowClear: !0,
                  className: "tableSelectPopupToolTagSelect",
                  style: {
                    width: "100%",
                    "--toolTagSelect-color": m ? d.colorTextDisabled : d.colorText
                  },
                  placeholder: "常用标签",
                  showSearch: !1,
                  disabled: m,
                  options: G,
                  value: Q,
                  onChange: X,
                  onDropdownVisibleChange: j
                }
              ) }) }),
              /* @__PURE__ */ e.jsx(a, { span: n.right.totalSelect, children: /* @__PURE__ */ e.jsx(h.Item, { children: /* @__PURE__ */ e.jsxs("div", { className: "tableSelectPopupTotalSelect", children: [
                /* @__PURE__ */ e.jsx(
                  C,
                  {
                    style: { width: "100%" },
                    mode: "multiple",
                    placeholder: "",
                    showSearch: !1,
                    options: l,
                    value: o,
                    fieldNames: s,
                    popupClassName: "tableSelectPopupTotalPopup",
                    dropdownRender: Z,
                    tagRender: () => /* @__PURE__ */ e.jsx(e.Fragment, {}),
                    onDropdownVisibleChange: j
                  }
                ),
                /* @__PURE__ */ e.jsx("div", { className: "tableSelectPopupTotalSelectTip", children: k(
                  ["已选择", "条数据"],
                  o.length || 0
                ) })
              ] }) }) }),
              /* @__PURE__ */ e.jsx(a, { span: n.right.button, children: /* @__PURE__ */ e.jsx(
                A,
                {
                  type: "primary",
                  danger: !0,
                  onClick: () => u([], [], "clear"),
                  children: "清空"
                }
              ) }),
              /* @__PURE__ */ e.jsx(a, { span: n.right.button, children: /* @__PURE__ */ e.jsx(
                A,
                {
                  type: "primary",
                  onClick: () => u([], [], "confirm"),
                  children: "确认"
                }
              ) })
            ] }) })
          ] }) }) }) }),
          /* @__PURE__ */ e.jsx(
            "div",
            {
              ...y && {
                className: "pointerMouse",
                onClick: () => L()
              },
              children: /* @__PURE__ */ e.jsx(
                se,
                {
                  spinning: y,
                  indicator: /* @__PURE__ */ e.jsx(ie, {}),
                  tip: /* @__PURE__ */ e.jsx(B.Text, { type: "danger", children: "加载失败，点击重试" }),
                  children: /* @__PURE__ */ e.jsx(
                    v,
                    {
                      rowKey: s.value,
                      loading: m,
                      bordered: !0,
                      sticky: !0,
                      size: "small",
                      scroll: { y: 370 },
                      pagination: !1,
                      rowSelection: q,
                      columns: $,
                      dataSource: F,
                      ...y && { className: "loadingFailedTable" },
                      ...Y()
                    }
                  )
                }
              )
            }
          ),
          /* @__PURE__ */ e.jsx(h, { children: /* @__PURE__ */ e.jsx(h.Item, { style: { marginBottom: 0 }, children: /* @__PURE__ */ e.jsx(
            re,
            {
              disabled: m,
              className: "tableSelectPopupTablePagination",
              size: "small",
              current: P.pageIndex,
              pageSize: P.pageSize,
              showTotal: (t) => k(["共", "条"], t),
              showSizeChanger: !0,
              showQuickJumper: !0,
              total: K,
              onChange: U,
              pageSizeOptions: ["10", "20", "50", "100"]
            }
          ) }) })
        ]
      }
    ) })
  ] });
}
export {
  ye as default
};
